include<lib.scad>

$fa = 1;
$fs = 0.2;

delta = 0.005;

lip_offset_left = 54.95;
lip_width = 109.8;
lip_height = 9.0;
lip_offset_right = 47.9;

width = lip_offset_left + lip_width + lip_offset_right;
height = 100.9;
thickness = 7.0;

new_height = 90.0; // using height value from the < late 2005 DP models 

// very approximate radii:

radius_main = 2.0;
radius_lip = 2.5; 
radius_side_cutout = 2.5;
radius_top_screw_cutout = 2.5;
radius_heatsink_cutout = 2;
radius_vrm_heatsink_mount_plate_cutout = 2;

side_cutout_width = 24.9;
side_cutout_height = 68.8;
side_cutout_offset_top = 10.85;
side_cutout_offset_bottom = 21.25;

side_cutout_height_adj = height * (side_cutout_height / (side_cutout_height+side_cutout_offset_top + side_cutout_offset_bottom));
side_cutout_offset_bottom_adj = height * (side_cutout_offset_bottom / (side_cutout_height+side_cutout_offset_top + side_cutout_offset_bottom));

top_screw_cutout_right_offset = 8.7;
top_screw_cutout_width = 8.7;
top_screw_cutout_height = 8.35;

decorative_plate_cutout_offset_left = 139.0;
decorative_plate_cutout_offset_right = 67.7;
decorative_plate_cutout_width = 6.0;
decorative_plate_cutout_height = 2.0;

decorative_plate_cutout_offset_left_adj = width * (decorative_plate_cutout_offset_left / (decorative_plate_cutout_offset_left + decorative_plate_cutout_offset_right + decorative_plate_cutout_width));
decorative_plate_cutout_width_adj = width * (decorative_plate_cutout_width / (decorative_plate_cutout_offset_left + decorative_plate_cutout_offset_right + decorative_plate_cutout_width));
decorative_plate_cutout_radius = sqrt(((decorative_plate_cutout_width_adj/2)^2+decorative_plate_cutout_height^2)^2/4/(decorative_plate_cutout_height^2)+(decorative_plate_cutout_width_adj/2)^2);
decorative_plate_cutout_center_offset = decorative_plate_cutout_radius - decorative_plate_cutout_height;

processor_mount_hole_diameter_large = 8.5;
processor_mount_hole_diameter_thread_inner = 2.4;
processor_mount_hole_depth = 3.8;
processor_mount_holes_interhole_distance_heightwise = 70.5;
processor_mount_holes_interhole_distance_widthwise_1 = 47.5;
processor_mount_holes_interhole_distance_widthwise_2 = 78.5;
processor_mount_holes_offset_top = 1.5;
processor_mount_holes_offset_left = 12.7;
processor_mount_holes_offset_right = 49.2;
processor_mount_holes_offset_bottom = 12.4;
processor_mount_holes_offset_lip = 21.4;

socket_pindown_hole_diameter = 7.5;
socket_pindown_holes_offset_processor_mount_holes_wise_right = 1.15;
socket_pindown_holes_offset_processor_mount_holes_wise_left = 69.8;

processor_mount_holes_offset_left_adj = width * (processor_mount_holes_offset_left / (processor_mount_holes_offset_left + processor_mount_holes_interhole_distance_widthwise_1 + processor_mount_holes_interhole_distance_widthwise_2 + processor_mount_holes_offset_right + 3 * processor_mount_hole_diameter_large));
processor_mount_holes_offset_top_adj_1 = height * (processor_mount_holes_offset_top / (processor_mount_holes_offset_top + processor_mount_holes_interhole_distance_heightwise + processor_mount_holes_offset_bottom + 2 * processor_mount_hole_diameter_large));
processor_mount_holes_offset_top_adj_2 = (height + lip_height) * (processor_mount_holes_offset_top / (processor_mount_holes_offset_top + processor_mount_holes_interhole_distance_heightwise + processor_mount_holes_offset_lip + 2 * processor_mount_hole_diameter_large));
processor_mount_holes_offset_top_adj_avg = (processor_mount_holes_offset_top_adj_1 + processor_mount_holes_offset_top_adj_2) / 2;

socket_pindown_holes_offset_processor_mount_holes_wise_right_adj = processor_mount_holes_interhole_distance_widthwise_2 * (socket_pindown_holes_offset_processor_mount_holes_wise_right / (socket_pindown_holes_offset_processor_mount_holes_wise_right + socket_pindown_holes_offset_processor_mount_holes_wise_left + socket_pindown_hole_diameter));


processor_mount_holes_interhole_offset_heightwise = processor_mount_holes_interhole_distance_heightwise + processor_mount_hole_diameter_large;
processor_mount_holes_interhole_offset_widthwise_1 = processor_mount_holes_interhole_distance_widthwise_1 + processor_mount_hole_diameter_large;
processor_mount_holes_interhole_offset_widthwise_2 = processor_mount_holes_interhole_distance_widthwise_2 + processor_mount_hole_diameter_large;

mount_hole_diameter = 5.0;
mount_holes_offset_left = 1.2;
mount_holes_offset_top_1 = 1.5;
mount_holes_offset_bottom_1 = 12.2;
mount_holes_distance_heightwise_1 = 77.1;
mount_holes_offset_right = 1.8;
mount_holes_offset_top_2 = 1.5;
mount_holes_offset_bottom_2 = 2.2;
mount_holes_distance_heightwise_2 = 86.9;
mount_holes_distance_heightwise_2_mod = 77.1;

mount_holes_offset_top_1_adj = height * (mount_holes_offset_top_1 / (mount_holes_offset_top_1 + mount_holes_distance_heightwise_1 + mount_holes_offset_bottom_1 + 2 * mount_hole_diameter));
mount_holes_offset_top_2_adj = height * (mount_holes_offset_top_2 / (mount_holes_offset_top_2 + mount_holes_distance_heightwise_2 + mount_holes_offset_bottom_2 + 2 * mount_hole_diameter));
mount_holes_offset_top_adj = (mount_holes_offset_top_1_adj + mount_holes_offset_top_2_adj) / 2;

alignment_hole_diameter = 8.45;
alignment_holes_offset_right = 4.7;
alignment_holes_offset_bottom = 38.2;
alignment_holes_distance = 18.1;

vrm_heatsink_mount_hole_diameter_large = 12.0;
vrm_heatsink_mount_hole_diameter_small = 5.7;
vrm_heatsink_mount_hole_slit_width = 4.1;
vrm_heatsink_mount_hole_backside_depth = 6.1;

// Offsets and distances for small diameter holes / slits
vrm_heatsink_mount_holes_offset_left = 32.65;
vrm_heatsink_mount_holes_offset_top = 23.7;
vrm_heatsink_mount_holes_offset_bottom = 34.5;
vrm_heatsink_mount_holes_distance = 34.0;

vrm_heatsink_mount_holes_offset_bottom_adj = height * (vrm_heatsink_mount_holes_offset_bottom / (vrm_heatsink_mount_holes_offset_top + vrm_heatsink_mount_holes_offset_bottom + vrm_heatsink_mount_holes_distance + 2 * vrm_heatsink_mount_hole_slit_width));
vrm_heatsink_mount_holes_offset_distance_adj = height * (vrm_heatsink_mount_holes_distance / (vrm_heatsink_mount_holes_offset_top + vrm_heatsink_mount_holes_offset_bottom + vrm_heatsink_mount_holes_distance + 2 * vrm_heatsink_mount_hole_slit_width));

heatsink_cutout_width = 90.3;
heatsink_cutout_height_1 = 47.0;
heatsink_cutout_height_2 = 40.4;
heatsink_cutout_transition_width = 14.0;
heatsink_cutout_section_1_width = 11.0;
heatsink_cutout_offset_top = 24.4;
heatsink_cutout_offset_bottom_1 = 38.35;
heatsink_cutout_offset_bottom_2 = 45.0;
heatsink_cutout_offset_left = 72.7;
heatsink_cutout_offset_right = 49.8;

heatsink_cutout_offset_top_1_adj = (height + lip_height) * (heatsink_cutout_offset_top / (heatsink_cutout_offset_top + heatsink_cutout_height_1 + heatsink_cutout_offset_bottom_1));
heatsink_cutout_offset_top_2_adj = (height + lip_height) * (heatsink_cutout_offset_top / (heatsink_cutout_offset_top + heatsink_cutout_height_2 + heatsink_cutout_offset_bottom_2));
heatsink_cutout_offset_top_adj_avg = (heatsink_cutout_offset_top_1_adj + heatsink_cutout_offset_top_2_adj) / 2;
heatsink_cutout_offset_left_adj = width * (heatsink_cutout_offset_left / (heatsink_cutout_offset_left + heatsink_cutout_width + heatsink_cutout_offset_right));

vrm_heatsink_mount_plate_cutout_width = 11.0;
vrm_heatsink_mount_plate_cutout_height = 8.0;
vrm_heatsink_mount_plate_cutout_depth = 1.0;
vrm_heatsink_mount_plate_cutout_hole_diameter = 1.6;
vrm_heatsink_mount_plate_cutout_hole_offset_left = 4.25;
vrm_heatsink_mount_plate_cutout_hole_offset_right = 5.15;
vrm_heatsink_mount_plate_cutout_hole_offset_cutout = 3.15;

heatsink_mount_area_width = 42.0;
heatsink_mount_area_height = 52.2;
heatsink_mount_area_depth = 0.2;
heatsink_mount_area_processor_hole_diameter_plate = 2.6;
heatsink_mount_area_processor_hole_diameter = 3; // approximated fitting dimension
heatsink_mount_area_processor_hole_distance_widthwise = 31.6;
heatsink_mount_area_processor_hole_distance_heightwise = 43.6;
heatsink_mount_area_hole_diameter_plate = 3.2;
heatsink_mount_area_hole_diameter = 2.5; // approximated fitting dimension
heatsink_mount_area_hole_offset = 1.4;

heatsink_mount_area_overlap_top = 5.5;
heatsink_mount_area_overlap_bottom = 6.0;
heatsink_mount_area_offset_left = 22.3;
heatsink_mount_area_offset_right = 26.0;

heatsink_mount_area_overlap_top_adj = heatsink_mount_area_height * (heatsink_mount_area_overlap_top / (heatsink_mount_area_overlap_top + heatsink_cutout_height_2 + heatsink_mount_area_overlap_bottom));
heatsink_mount_area_offset_left_adj = heatsink_cutout_width * (heatsink_mount_area_offset_left / (heatsink_mount_area_offset_left + heatsink_mount_area_width + heatsink_mount_area_offset_right));

heatsink_mount_area_center_x = heatsink_cutout_offset_left_adj + heatsink_mount_area_offset_left_adj + heatsink_mount_area_width/2;
heatsink_mount_area_center_y = height - heatsink_cutout_offset_top_adj_avg + heatsink_mount_area_overlap_top_adj - heatsink_mount_area_height/2;

module inset_hole(diameter_inner, diameter_outer, inset, height) {
    translate([0,0,-delta])
    ihole(diameter_inner, diameter_outer, inset+delta, height+2*delta);
}

module processor_mount_hole() {
    inset_hole(processor_mount_hole_diameter_thread_inner, processor_mount_hole_diameter_large, processor_mount_hole_depth, thickness);
}

module socket_pindown_hole() {
    translate([0,0,-delta])
    linear_extrude(thickness+2*delta)
    circle(socket_pindown_hole_diameter/2);
}

module processor_mount_holes() {
    translate([processor_mount_holes_offset_left_adj+processor_mount_hole_diameter_large/2,height-(processor_mount_holes_offset_top_adj_avg+processor_mount_hole_diameter_large/2),0])
    union() {
        translate([0,0,0])
        processor_mount_hole();
        
        translate([processor_mount_holes_interhole_offset_widthwise_1,0,0])
        processor_mount_hole();
        
        translate([processor_mount_holes_interhole_offset_widthwise_1+processor_mount_holes_interhole_offset_widthwise_2,0,0])
        processor_mount_hole();
        
        translate([0,-processor_mount_holes_interhole_offset_heightwise,0])
        processor_mount_hole();
        
        translate([processor_mount_holes_interhole_offset_widthwise_1,-processor_mount_holes_interhole_offset_heightwise,0])
        processor_mount_hole();
        
        translate([processor_mount_holes_interhole_offset_widthwise_1+processor_mount_holes_interhole_offset_widthwise_2,-processor_mount_holes_interhole_offset_heightwise,0])
        processor_mount_hole();
        
        translate([processor_mount_holes_interhole_offset_widthwise_1+processor_mount_holes_interhole_offset_widthwise_2-socket_pindown_holes_offset_processor_mount_holes_wise_right_adj-processor_mount_hole_diameter_large/2-socket_pindown_hole_diameter/2,0,0])
        socket_pindown_hole();
        
        translate([processor_mount_holes_interhole_offset_widthwise_1+processor_mount_holes_interhole_offset_widthwise_2-socket_pindown_holes_offset_processor_mount_holes_wise_right_adj-processor_mount_hole_diameter_large/2-socket_pindown_hole_diameter/2,-processor_mount_holes_interhole_offset_heightwise,0])
        socket_pindown_hole();
    }
}

module mount_hole() {
    translate([0,0,-delta])
    linear_extrude(thickness+2*delta)
    circle(mount_hole_diameter/2);
}

module mount_holes() {
    translate([mount_holes_offset_left+mount_hole_diameter/2,height-mount_hole_diameter/2-mount_holes_offset_top_adj,0])
    union() {
        translate([0,0,0])
        mount_hole();
        
        translate([0,-mount_hole_diameter-mount_holes_distance_heightwise_1,0])
        mount_hole();
    }
    
    translate([width-mount_hole_diameter/2-mount_holes_offset_right,height-mount_hole_diameter/2-mount_holes_offset_top_adj,0])
    union() {
        translate([0,0,0])
        mount_hole();
        
        translate([0,-mount_hole_diameter-mount_holes_distance_heightwise_2_mod,0])
        mount_hole();
    }
}

module alignment_hole() {
    translate([0,0,-delta])
    linear_extrude(thickness+2*delta)
    circle(alignment_hole_diameter/2);
}

module alignment_holes() {
    translate([width-alignment_holes_offset_right-alignment_hole_diameter/2,alignment_holes_offset_bottom+alignment_hole_diameter/2,0])
    union() {
        translate([0,0,0])
        alignment_hole();
        
        translate([0,alignment_hole_diameter+alignment_holes_distance,0])
        alignment_hole();
    }
}

module vrm_heatsink_mount_hole() {
    translate([0,0,-delta])
    union() {
        linear_extrude(vrm_heatsink_mount_hole_backside_depth+delta)
        circle(vrm_heatsink_mount_hole_diameter_large/2);
    
        linear_extrude(thickness+2*delta)
        intersection() {
            circle(vrm_heatsink_mount_hole_diameter_small/2);
            
            square([vrm_heatsink_mount_hole_diameter_small+2*delta,vrm_heatsink_mount_hole_slit_width], true);
        }
    }
}

module vrm_heatsink_mount_holes() {
    translate([vrm_heatsink_mount_holes_offset_left+vrm_heatsink_mount_hole_diameter_small/2,vrm_heatsink_mount_holes_offset_bottom_adj+vrm_heatsink_mount_hole_slit_width/2,0])
    union() {
        translate([0,0,0])
        vrm_heatsink_mount_hole();
        
        translate([0,vrm_heatsink_mount_holes_offset_distance_adj+vrm_heatsink_mount_hole_slit_width,0])
        vrm_heatsink_mount_hole();
    }
}

module vrm_heatsink_mount_plate_cutout() {
    translate([heatsink_cutout_offset_left_adj,height-heatsink_cutout_height_1-vrm_heatsink_mount_plate_cutout_height-heatsink_cutout_offset_top_adj_avg,thickness-vrm_heatsink_mount_plate_cutout_depth])
    difference() {
        union() {
            linear_extrude(vrm_heatsink_mount_plate_cutout_depth+2*delta)
            square([vrm_heatsink_mount_plate_cutout_width, heatsink_cutout_height_1+2*vrm_heatsink_mount_plate_cutout_height]);
            
            translate([vrm_heatsink_mount_plate_cutout_hole_offset_left+vrm_heatsink_mount_plate_cutout_hole_diameter/2,vrm_heatsink_mount_plate_cutout_height-vrm_heatsink_mount_plate_cutout_hole_offset_cutout-vrm_heatsink_mount_plate_cutout_hole_diameter/2,-thickness-delta])
            linear_extrude(thickness+2*delta)
            circle(vrm_heatsink_mount_plate_cutout_hole_diameter/2);
            
            translate([vrm_heatsink_mount_plate_cutout_hole_offset_left+vrm_heatsink_mount_plate_cutout_hole_diameter/2,heatsink_cutout_height_1+vrm_heatsink_mount_plate_cutout_height+vrm_heatsink_mount_plate_cutout_hole_diameter/2+vrm_heatsink_mount_plate_cutout_hole_offset_cutout,-thickness-delta])
            linear_extrude(thickness+2*delta)
            circle(vrm_heatsink_mount_plate_cutout_hole_diameter/2);
        }
        
        translate([0,0,0])
        hs_rounding(radius_vrm_heatsink_mount_plate_cutout, 180);
        
        translate([0,heatsink_cutout_height_1+2*vrm_heatsink_mount_plate_cutout_height,0])
        hs_rounding(radius_vrm_heatsink_mount_plate_cutout, 90);
        
        translate([vrm_heatsink_mount_plate_cutout_width,heatsink_cutout_height_1+2*vrm_heatsink_mount_plate_cutout_height,0])
        hs_rounding(radius_vrm_heatsink_mount_plate_cutout, 0);
        
        translate([vrm_heatsink_mount_plate_cutout_width,0,0])
        hs_rounding(radius_vrm_heatsink_mount_plate_cutout, -90);
    }
}

module heatsink_mount_cutout_shape() {
    translate([heatsink_cutout_offset_left_adj,height-heatsink_cutout_offset_top_adj_avg-heatsink_cutout_height_2,0])
    polygon([
        [0,heatsink_cutout_height_2-heatsink_cutout_height_1],
        [0,heatsink_cutout_height_2],
        [heatsink_cutout_width,heatsink_cutout_height_2],
        [heatsink_cutout_width,0],
        [heatsink_cutout_section_1_width+heatsink_cutout_transition_width,0],
        [heatsink_cutout_section_1_width,heatsink_cutout_height_2-heatsink_cutout_height_1]
    ]);
}

module heatsink_mount_area() {
    translate([0,0,thickness-delta])
    linear_extrude(heatsink_mount_area_depth+delta)
    difference() {
        translate([heatsink_mount_area_center_x,heatsink_mount_area_center_y,0])
        square([heatsink_mount_area_width, heatsink_mount_area_height], true);
        
        heatsink_mount_cutout_shape();
    }
}

module heatsink_mount_area_holes() {
    translate([heatsink_mount_area_center_x,heatsink_mount_area_center_y,-delta])
    linear_extrude(thickness+heatsink_mount_area_depth+2*delta)
    union() {
        translate([(heatsink_mount_area_processor_hole_distance_widthwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),(heatsink_mount_area_processor_hole_distance_heightwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),0])
        circle(heatsink_mount_area_processor_hole_diameter/2);
        
        translate([-(heatsink_mount_area_processor_hole_distance_widthwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),(heatsink_mount_area_processor_hole_distance_heightwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),0])
        circle(heatsink_mount_area_processor_hole_diameter/2);
        
        translate([(heatsink_mount_area_processor_hole_distance_widthwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),-(heatsink_mount_area_processor_hole_distance_heightwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),0])
        circle(heatsink_mount_area_processor_hole_diameter/2);
        
        translate([-(heatsink_mount_area_processor_hole_distance_widthwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),-(heatsink_mount_area_processor_hole_distance_heightwise/2+heatsink_mount_area_processor_hole_diameter_plate/2),0])
        circle(heatsink_mount_area_processor_hole_diameter/2);
        
        translate([0,heatsink_mount_area_height/2-heatsink_mount_area_hole_diameter_plate/2-heatsink_mount_area_hole_offset,0])
        circle(heatsink_mount_area_hole_diameter/2);
        
        translate([0,-heatsink_mount_area_height/2+heatsink_mount_area_hole_diameter_plate/2+heatsink_mount_area_hole_offset,0])
        circle(heatsink_mount_area_hole_diameter/2);
    }
}

module hs_rounding(radius, angle) {
    translate([0,0,-delta])
    rounding(delta, radius, thickness + 2*delta, angle);
}

module heatsink_plate() {
    difference() {
        union() {        
            linear_extrude(thickness)
            difference() {
                union() {
                    // Main Rectangle
                    translate([0,height-new_height,0])
                    square([width, new_height]);
                }
                
                // Side Cutout
                translate([0,side_cutout_offset_bottom_adj,0])
                square([side_cutout_width, side_cutout_height_adj]);
                
                // Top Screw Cutout
                translate([width-top_screw_cutout_right_offset-top_screw_cutout_width/2,height-(top_screw_cutout_height-top_screw_cutout_width/2)+delta, 0])
                rectircle(top_screw_cutout_width/2, top_screw_cutout_height-top_screw_cutout_width/2);
                
                // Bottom Screw Cutout
                translate([width-top_screw_cutout_right_offset-top_screw_cutout_width/2,height-new_height+(top_screw_cutout_height-top_screw_cutout_width/2)-delta, 0])
                rotate([0,0,180])
                rectircle(top_screw_cutout_width/2, top_screw_cutout_height-top_screw_cutout_width/2);
                
                // Decorative Plate Cutout (Top)
                translate([decorative_plate_cutout_offset_left_adj+decorative_plate_cutout_width_adj/2,height+decorative_plate_cutout_center_offset,0])
                circle(decorative_plate_cutout_radius);
                
                // Decorative Plate Cutout (Bottom)
                translate([decorative_plate_cutout_offset_left_adj+decorative_plate_cutout_width_adj/2,height-new_height-decorative_plate_cutout_center_offset,0])
                circle(decorative_plate_cutout_radius);
                
                // Heatsink Mount Cutout
                heatsink_mount_cutout_shape();
            };
            
            // Rounding Inner (Side Cutout)
            union() {
                translate([side_cutout_width,side_cutout_offset_bottom_adj,0])
                hs_rounding(radius_side_cutout, -90);
                
                translate([side_cutout_width,side_cutout_offset_bottom_adj+side_cutout_height_adj,0])
                hs_rounding(radius_side_cutout, 0);
            }
            
            // Rounding Inner (Heatsink Mount Cutout)
            union() {
                translate([heatsink_cutout_offset_left_adj,height-heatsink_cutout_offset_top_adj_avg,0])
                hs_rounding(radius_heatsink_cutout, 90);
                
                translate([heatsink_cutout_offset_left_adj,height-heatsink_cutout_height_1-heatsink_cutout_offset_top_adj_avg,0])
                hs_rounding(radius_heatsink_cutout, 180);
                
                translate([heatsink_cutout_offset_left_adj+heatsink_cutout_width,height-heatsink_cutout_offset_top_adj_avg,0])
                hs_rounding(radius_heatsink_cutout, 0);
                
                translate([heatsink_cutout_offset_left_adj+heatsink_cutout_width,height-heatsink_cutout_height_2-heatsink_cutout_offset_top_adj_avg,0])
                hs_rounding(radius_heatsink_cutout, -90);
            }
            
            heatsink_mount_area();
        }
        
        // Rounding Outer (Main)
        union() {
            translate([0,height-new_height,0])
            translate([0,0,0])
            hs_rounding(radius_main, 180);
            
            translate([width,height,0])
            hs_rounding(radius_main, 0);
            
            translate([0,height-new_height,0])
            translate([width,0,0])
            hs_rounding(radius_main, -90);
            
            translate([0,height,0])
            hs_rounding(radius_main, 90);
        }
        
        // Rounding Outer (Side Cutout)
        union() {
            translate([0,side_cutout_offset_bottom_adj,0])
            hs_rounding(radius_side_cutout, 90);
            
            translate([0,side_cutout_offset_bottom_adj+side_cutout_height_adj,0])
            hs_rounding(radius_side_cutout, 180);
        }
        
        // Rounding Outer (Top Screw Cutout)
        union() {
            translate([width-top_screw_cutout_right_offset, height, 0])
            hs_rounding(radius_top_screw_cutout, 90);
            
            translate([width-top_screw_cutout_right_offset-top_screw_cutout_width, height, 0])
            hs_rounding(radius_top_screw_cutout, 0);
            
            translate([width-top_screw_cutout_right_offset, height-new_height, 0])
            hs_rounding(radius_top_screw_cutout, 180);
            
            translate([width-top_screw_cutout_right_offset-top_screw_cutout_width, height-new_height, 0])
            hs_rounding(radius_top_screw_cutout, -90);
        }
        
        // Processor Mount Holes
        processor_mount_holes();
        
        // Mount Holes
        mount_holes();
        
        // Two Huge Alignment Holes
        alignment_holes();
        
        // Holes for mounting the VRM Heatsink to the Heatsink Plate
        vrm_heatsink_mount_holes();
        
        // Cutout for the plate to which VRM Heatsink is partially mounted
        vrm_heatsink_mount_plate_cutout();

        heatsink_mount_area_holes();
    }
}

heatsink_plate();