module rectircle(r, l) {
    union() {
        translate([0,l/2,0])
        square([2*r, l], true);
        difference() {
            circle(r);                
            translate([0,r+delta,0])
            square([2*r, 2*r], true);
        }
    }
}

module rounding(delta, r, t, a) {
    rotate([0,0,a])
    translate([-r,-r,0])
    linear_extrude(t)
    difference() {
        square([r+delta,r+delta]);
        circle(r);
    }
}

module chamfer(delta, l1, l2, t, a) {
    diagonal = sqrt(l1^2 + l2^2);
    rotation_angle = asin(l1/diagonal);
    distance = l1*cos(rotation_angle);
    rotation_center_offset = diagonal/2-l1*sin(rotation_angle);
    
    rotate([0,0,a])
    translate([-l1,-l2,0])
    linear_extrude(t)
    difference() {
        square([l1+delta,l2+delta]);
        
        rotate([0,0,rotation_angle])
        translate([0,rotation_center_offset,0])
        square([2*distance, diagonal+2*delta], true);
    }
}

module ihole(di, do, i, h) {
    union() {
        linear_extrude(h)
        circle(di/2);
        
        translate([0,0,h-i])
        linear_extrude(i)
        circle(do/2);
    }
}