include<lib.scad>

$fa = 1;
$fs = 0.2;

delta = 0.005;

thickness = 1.83;

height = 88.96;
halfheight = height/2;
// widths are calculated later on after the variables they are derived from are declared

cutin_height = 9.98;

chamfer_length = 2.0; // approximate
cutin_radius = 2.5; // approximate

secondary_mount_hole_diameter = 4.00;
secondary_mount_hole_offset_left = 3.26;
secondary_mount_hole_offset_top = 3.1;

mount_hole_diameter = 4.48;
mount_hole_offset_left_1 = 9.62;
mount_hole_offset_left_2 = 96.48;
mount_hole_offset_right_2 = 60.18;
mount_hole_offset_right_3 = 4.28;
mount_hole_offset_top = 2.85;
mount_hole_distance_2_to_3 = 51.45;

socket_pindown_hole_diameter = 4.48;
socket_pindown_hole_offset_left = 18.75;
socket_pindown_hole_offset_top = 2.85;

vrm_heatsink_mount_hole_diameter = 3.52;
vrm_heatsink_mount_hole_offset_left_1 = 91.61;
vrm_heatsink_mount_hole_offset_left_2 = 133.89;
vrm_heatsink_mount_hole_offset_right_2 = 50.12;
vrm_heatsink_mount_hole_offset_top_1 = 28.25;
vrm_heatsink_mount_hole_offset_top_2 = 23.62;
vrm_heatsink_mount_hole_distance_1 = 25.44;
vrm_heatsink_mount_hole_distance_2 = 34.76;
vrm_heatsink_mount_hole_distance_1_to_2 = 39.13;
vrm_heatsink_mount_hole_center_diameter_id = 2.5;
vrm_heatsink_mount_hole_center_diameter_post = 5.54;
vrm_heatsink_mount_hole_center_post_height = 3.04;
vrm_heatsink_mount_hole_distance_1_to_center = 19.60;
vrm_heatsink_mount_hole_distance_center_to_2 = 28.40;

vrm_heatsink_mount_hole_center_angle_left = asin((vrm_heatsink_mount_hole_distance_1 / 2 + vrm_heatsink_mount_hole_diameter / 2) / (vrm_heatsink_mount_hole_diameter / 2 + vrm_heatsink_mount_hole_center_diameter_id / 2 + vrm_heatsink_mount_hole_distance_1_to_center));
vrm_heatsink_mount_hole_center_angle_right = asin((vrm_heatsink_mount_hole_distance_2 / 2 + vrm_heatsink_mount_hole_diameter / 2) / (vrm_heatsink_mount_hole_diameter / 2 + vrm_heatsink_mount_hole_center_diameter_id / 2 + vrm_heatsink_mount_hole_distance_center_to_2));
vrm_heatsink_mount_hole_center_projected_distance_left = (vrm_heatsink_mount_hole_diameter / 2 + vrm_heatsink_mount_hole_center_diameter_id / 2 + vrm_heatsink_mount_hole_distance_1_to_center) * cos(vrm_heatsink_mount_hole_center_angle_left);
vrm_heatsink_mount_hole_center_projected_distance_right = (vrm_heatsink_mount_hole_diameter / 2 + vrm_heatsink_mount_hole_center_diameter_id / 2 + vrm_heatsink_mount_hole_distance_center_to_2) * cos(vrm_heatsink_mount_hole_center_angle_right);
vrm_heatsink_mount_hole_center_projected_distance_left_adj = (vrm_heatsink_mount_hole_offset_left_2 - vrm_heatsink_mount_hole_offset_left_1) * (vrm_heatsink_mount_hole_center_projected_distance_left / (vrm_heatsink_mount_hole_center_projected_distance_left + vrm_heatsink_mount_hole_center_projected_distance_right));
vrm_heatsink_mount_hole_center_centerpos_left = vrm_heatsink_mount_hole_center_projected_distance_left_adj + vrm_heatsink_mount_hole_diameter / 2 + vrm_heatsink_mount_hole_offset_left_1;

width_1 = mount_hole_offset_left_2 + mount_hole_diameter + mount_hole_offset_right_2;
width_3 = vrm_heatsink_mount_hole_offset_left_2 + vrm_heatsink_mount_hole_diameter + vrm_heatsink_mount_hole_offset_right_2;

width_2 = 139.00;
height_2 = 68.86;
height_3 = 48.96;

processor_pindown_hole_diameter = 4.00;
processor_pindown_hole_offset_left = 36.1;
processor_pindown_hole_offset_top = 19.44;
processor_pindown_hole_distance_heightwise = 42.22;
processor_pindown_hole_distance_widthwise = 30.22;

processor_package_width = 25.10;
processor_package_height = 25.10;
processor_package_thickness = 1.5; // approximate (hard to measure)
processor_die_width = 11.67;
processor_die_height = 13.32;
processor_die_thickness = (0.908 + 0.779) / 2; // as per 970MP datasheet

socket_height = 44.00;
socket_width = 17.32;
socket_depth = 3.78;
socket_offset_left = 12.16;
socket_offset_top = 22.46;

terminal_hole_diameter = 4.00;
terminal_hole_offset_right = 3.00;
terminal_hole_offset_top = 14.90;
terminal_hole_offset_bottom = 13.56;
terminal_hole_distance = 12.70;

weird_hole_diameter = 2.98;
weird_hole_offset_right = 2.4;
weird_hole_offset_bottom = 2.3;

module mount_hole() {
    translate([mount_hole_diameter/2,-mount_hole_diameter/2,0])
    circle(mount_hole_diameter/2);
}

module secondary_mount_hole() {
    translate([secondary_mount_hole_diameter/2,-secondary_mount_hole_diameter/2,0])
    circle(secondary_mount_hole_diameter/2);
}

module socket_pindown_hole() {
    translate([socket_pindown_hole_diameter/2,-socket_pindown_hole_diameter/2,0])
    circle(socket_pindown_hole_diameter/2);
}

module mounting_holes_onesided() {
    translate([0,halfheight,0])
    union() {
        translate([secondary_mount_hole_offset_left, -secondary_mount_hole_offset_top, 0])
        secondary_mount_hole();
        
        translate([mount_hole_offset_left_1,-mount_hole_offset_top,0])
        mount_hole();
        
        translate([mount_hole_offset_left_2,-mount_hole_offset_top,0])
        mount_hole();
        
        translate([mount_hole_offset_left_2+mount_hole_diameter+mount_hole_distance_2_to_3,-mount_hole_offset_top,0])
        mount_hole();
        
        translate([socket_pindown_hole_offset_left, -socket_pindown_hole_offset_top, 0])
        socket_pindown_hole();
    }
}

module mounting_holes() {
    mounting_holes_onesided();
    
    mirror([0,1,0])
    mounting_holes_onesided();
}

module vrm_heatsink_mount_hole() {
    translate([vrm_heatsink_mount_hole_diameter/2,vrm_heatsink_mount_hole_diameter/2,0])
    circle(vrm_heatsink_mount_hole_diameter/2);
}

module vrm_heatsink_mount_holes_onesided() {
    translate([vrm_heatsink_mount_hole_offset_left_1,vrm_heatsink_mount_hole_distance_1/2,0])
    vrm_heatsink_mount_hole();
    
    translate([vrm_heatsink_mount_hole_offset_left_2,vrm_heatsink_mount_hole_distance_2/2,0])
    vrm_heatsink_mount_hole();
}

module vrm_heatsink_mount_holes() {
    translate([vrm_heatsink_mount_hole_center_centerpos_left,0,0])
    circle(vrm_heatsink_mount_hole_center_diameter_id/2);
    
    vrm_heatsink_mount_holes_onesided();
    
    mirror([0,1,0])
    vrm_heatsink_mount_holes_onesided();
}

module vrm_heatsink_mount_post() {
    translate([vrm_heatsink_mount_hole_center_centerpos_left,0,0])
    linear_extrude(thickness+vrm_heatsink_mount_hole_center_post_height)
    difference() {
        circle(vrm_heatsink_mount_hole_center_diameter_post/2);
        
        circle(vrm_heatsink_mount_hole_center_diameter_id/2);
    }
}

module processor_pindown_hole() {
    translate([processor_pindown_hole_diameter/2,processor_pindown_hole_diameter/2,0])
    circle(processor_pindown_hole_diameter/2);
}

module processor_pindown_holes_onesided() {
    translate([processor_pindown_hole_offset_left,processor_pindown_hole_distance_heightwise/2,0])
    processor_pindown_hole();
    
    translate([processor_pindown_hole_offset_left+processor_pindown_hole_diameter+processor_pindown_hole_distance_widthwise,processor_pindown_hole_distance_heightwise/2,0])
    processor_pindown_hole();
}

module processor_pindown_holes() {
    processor_pindown_holes_onesided();
    
    mirror([0,1,0])
    processor_pindown_holes_onesided();
}

module terminal_hole() {
    translate([-terminal_hole_diameter/2,-terminal_hole_diameter/2,0])
    circle(terminal_hole_diameter/2);
}

module terminal_holes() {
    translate([width_3,height_3/2,0])
    union() {
        translate([-terminal_hole_offset_right,-terminal_hole_offset_top,0])
        terminal_hole();
        
        translate([-terminal_hole_offset_right,-terminal_hole_offset_top-terminal_hole_diameter-terminal_hole_distance,0])
        terminal_hole();
    }
}

module weird_hole() {
    translate([-weird_hole_offset_right,weird_hole_offset_bottom,0])
    translate([width_3,-height_3/2,0])
    translate([-weird_hole_diameter/2,weird_hole_diameter/2,0])
    circle(weird_hole_diameter/2);
}

module processor_package() {
    translate([processor_pindown_hole_offset_left+processor_pindown_hole_diameter+processor_pindown_hole_distance_widthwise/2,0,-delta+thickness])
    union() {
        linear_extrude(processor_package_thickness+delta)
        square([processor_package_width, processor_package_height], true);
        
        linear_extrude(processor_package_thickness+processor_die_thickness+delta)
        square([processor_die_width, processor_die_height], true);
    }
}

module socket() {
    translate([socket_offset_left,0,0])
    translate([socket_width/2,0,-socket_depth])
    linear_extrude(socket_depth+delta)
    square([socket_width,socket_height], true);
}

module b_chamfer(a) {
    translate([0,0,-delta])
    chamfer(delta, chamfer_length, chamfer_length, thickness+2*delta, a);
}

module b_rounding(a) {
    translate([0,0,-delta])
    rounding(delta, cutin_radius, thickness+2*delta, a);
}

module processor_board() {
    difference() {
        union() {
            linear_extrude(thickness)
            difference() {
                // Main Polygon
                union() {
                    translate([0,-halfheight,0])
                    square([width_2, height]);
                    
                    translate([0,height_2/2,0])
                    square([width_1, (height-height_2)/2]);
                    
                    translate([0,-height_2/2-(height-height_2)/2,0])
                    square([width_1, (height-height_2)/2]);
                    
                    translate([0,-height_3/2,0])
                    square([width_3, height_3]);
                };
                
                // Main Mounting Holes (card, secondary, socket pindown)
                mounting_holes();
                
                // VRM Heatsink Mounting Holes
                vrm_heatsink_mount_holes();
                
                // Processor Pindown Holes
                processor_pindown_holes();
                
                // Terminal Holes on the left
                terminal_holes();
                
                // One Weird Hole underneath terminal holes
                weird_hole();
            }
            
            processor_package();
            
            vrm_heatsink_mount_post();

            socket();
            
            // Rounding
            union() {
                translate([width_2,height_2/2,0])
                b_rounding(90);
                
                translate([width_2,-height_2/2,0])
                b_rounding(180);
                
                translate([width_2,height_3/2,0])
                b_rounding(180);
                
                translate([width_2,-height_3/2,0])
                b_rounding(90);
            }
        };
        
        // Chamfers
        union() {
            translate([0,height/2,0])
            b_chamfer(90);
            
            translate([0,-height/2,0])
            b_chamfer(180);
            
            translate([width_1,-height/2,0])
            b_chamfer(-90);
            
            translate([width_1,height/2,0])
            b_chamfer(0);
            
            translate([width_1,-height_2/2,0])
            b_chamfer(0);
            
            translate([width_1,height_2/2,0])
            b_chamfer(-90);
            
            translate([width_3,-height_3/2,0])
            b_chamfer(-90);
            
            translate([width_3,height_3/2,0])
            b_chamfer(0);
        }
    }
}

processor_board();